/*

Copyright Yann OLLIVIER 1997-1999

This software may be freely distributed as is, including
this whole notice.

It may be modified, but any modification should include this whole notice as 
is and a description of the changes made.

This software may not be sold.

This software or any modified version of it may be freely used in free
programs. The program should include a copy of this whole notice. If you
want to use it in a program you sell, contact me

This software comes with absolutely no warranty.

*/

#include <stdio.h>
#include <gtk/gtk.h>
#include "../lists.h"
#include "../mathexpr.h"
#include "../rand.h"

struct TPoint{double x,y,t;TPoint*prec,*succ;};

class TCourbe
{public:
  TPoint*prem;
  TCourbe(){prem=NULL;};
  TCourbe(const TCourbe&);
  void AjouteDeb(double,double,double=0);
  void AjouteFin(double,double,double=0);
  void Detruit();~TCourbe(){Detruit();};
  TCourbe operator=(TCourbe);
};

#include "afaire.h"

class TFonction
{public:
  char*nom;ROperation*pexpr,*pexprder,*pexprder2;TList<TCourbe> LCourbes;
  RFunction func;
  double dr,minp,maxp;HPEN hp;
  char Calc,Active,Diff,ZCalc,opt,TestPtI,TestPts,IntS;
  int t;
  TFonction(){
    nom=new char[1];nom[0]=0;
    pexpr=new ROperation;pexprder=new ROperation;pexprder2=new ROperation;
    LCourbes=*new TList<TCourbe>;hp=CreatePen(PS_SOLID,1,RGB(255,255,255));
    Calc=0;Active=1;Diff=0;t=0;ZCalc=1;minp=maxp=ErrVal;
    opt=1;TestPtI=1;TestPts=0;IntS=TRUE;
  }
  TFonction(char*s,ROperation*pop,double drp,HPEN hpp,char Diffp,int tp,char ZCalcp,double minpp,double maxpp){
    nom=CopyStr(s);
    pexpr=pop;pexprder=new ROperation;pexprder2=new ROperation;LCourbes=*new TList<TCourbe>;
    dr=drp;hp=new Pen;*hp=*hpp;Calc=0;Active=1;Diff=Diffp;t=tp;
    ZCalc=ZCalcp;minp=minpp;maxp=maxpp;
    opt=1;TestPtI=1;TestPts=0;IntS=TRUE;
  }
  ~TFonction(){
    delete[]nom;LCourbes.Destroy();DeleteObject(hp);delete pexpr;delete pexprder;delete pexprder2;
  }
};

void quit();

class Fenetre
{public:
// Champs
  double xech,yech,xr,yr,xlc,ylc,xaxe,yaxe,xgrad,ygrad,xcurs,ycurs,esp,niv,
    xmax,ymax,xmin,ymin,dxsens,dysens,xyR;
  long int xpc,ypc;
  char EchUnif,Suivre,Contexte,FBornes,Interrupt,Wait;
  double x,y,t,r,a;RVar*pxvar,*pyvar,*ptvar,*prvar,*pavar;
  TFonction*PSelCourbeFonc;int SelCourbe;
  TList<TFonction> LFonctions;TFonction*PFoncSel;

  HPEN axep;GdkColor bgcolor;
  GtkWidget *window;
  HDC hdc,hdcMem;GdkPixmap *hbmMem,*hbmMemOld;GtkWidget * drawing_area;
  TList<TCourbe> LCourbesLim;char IndLimCourbes;
  Fenetre();~Fenetre();
  //  char CanClose();

  //Interface
  void Paint(GtkWidget*,GdkEventExpose*);
  void MouseMove(int,int);
  void Redraw();
  void Button1(int x,int y);
  void Trace();
  void FoncSelLChanged();
  void Family();
  void Level();
  void Cross();
  void Inflex();
  void LimCurves();
  void Panorama();
  void CrbDel();
  void FoncDel();
  int StringInFoncSelL(char*);
  int StringInFList(char*);
  void Load();void Merge();
  void Save();
  void SaveImagePPM();void SaveImageXPM();int GetPixelColor(guint32,char);
  char* ChargeChaine(FILE*);void SauveChaine(char*,FILE*);
  TCourbe* ChargeCourbe(FILE*);void SauveCourbe(TCourbe*,FILE*);
  ROperation* ChargeOperation(FILE*);void SauveOperation(ROperation*,FILE*);
  TFonction* ChargeFonction(FILE*);void SauveFonction(TFonction*,FILE*);
  
  void ActivateWait();
  void DeactivateWait();
  void ShowWait();
  void HideWait();
  char InterruptionToRepeat();
  char InterruptionNotToRepeat();
  void MessageBeep(int);
  void Retaille(long int,long int);
  void Retrace();
  
  //Fonctions mathmatiques
  inline double xlog(long int);inline double ylog(long int);
  inline long int xphys(double);inline long int yphys(double);
  void TraceCurs(HDC,double,double);
  void CalculeFonction(TFonction*);
  void CalculeFonctionX(TFonction*);void CalculeFonctionY(TFonction*);
  double PolarEch();double RMax();double RMin();
  void CalculeFonctionA(TFonction*);void CalculeFonctionR(TFonction*);
  void CalculeFonctionXYFT(TFonction*);void CalculeFonctionRAFT(TFonction*);
  void TraceFonction(HDC,TFonction*);void TraceCourbe(HDC,TCourbe*,HPEN);
  void TraceEqDiffYFX(HDC,double,double);
  void TraceEqDiffXFY(HDC,double,double);
  void TraceNiv(HDC,double,double,double=ErrVal);
  void TraceChamp(HDC,double,double);
  void TraceNiv2(HDC,double,double,double=ErrVal);
  void TraceChamp2(HDC,double,double);
  void TraceFamEqDiffYFX(HDC,double,double);
  void TraceFamEqDiffXFY(HDC,double,double);
  void TraceFamNiv(HDC,double,double);
  void TraceFamChamp(HDC,double,double);
  void ChercheNiv(HDC,double&,double&,char=1);
  char ChercheNivAutour(HDC,double&,double&,char);
  void TraceEqDiffXYFXY(HDC,double,double);
  void TraceFamEqDiffXYFXY(HDC,double,double);
  char TestePoint(TCourbe*,double,double,double);
  void ChercheElts(HDC,char);
  void AnalyseEqDiffYFX(double&,double&,double&);
  void AnalyseEqDiffXFY(double&,double&,double&);
  void ChercheCroisement(HDC,double,double,char);
  void TraceCroisement(HDC,double,double,double,char);
  void ChercheInflexion(HDC,double,double,char);
  PROperation DeriveX(PROperation);PROperation DeriveY(PROperation);
  double TestePointLim(double,double,double);
    
  //Functions window
  void SetupFuncDial();
  GtkWidget *FuncDial;
  int Sel,coord,ExprEdCh,drEdCh,minpEdCh,maxpEdCh;
  GtkWidget *ExprEd,*drEd,*minpEd,*maxpEd;
  GtkWidget *FList,*TypeList;
  GtkWidget *ActiveCB,*ZCalcCB,*RetraceCB;
  GtkWidget *FoncRB,*DiffRB,*NivRB,*ChampRB,*Diff2RB;
  GtkWidget *OptB,*FuncColorB,*RecalcB,*Redraw2B;
  GtkWidget *IntSt,*NatureGB;
  GtkWidget *FuncValB,*FuncNewB,*FuncDestroyB,*FuncRenB;
  void FuncDialDisplay();
  GtkWidget *FuncColorSelDial;
  void FuncColorSelDialog();
  void FuncColorSelDialogOK();
  void FuncColorSelDialogCancel();
  GdkColor FuncColor_temp;
  void FixeTypes();void FixeParams();
  void Coords(int);void Nature();
  void FuncOK();
  char UpdateDependencies(int);
  void FListSelect(int);void FListUnselect();
  void FuncDestroy();void FuncNew();void FuncRen();void FuncRecalc();
  void FuncDestroyWithoutCheck(int);

  //Actions window
  void SetupActDial();
  GList* FoncSelList;
  GtkWidget *ActDial;
  GtkWidget *XPos,*YPos,*RPos,*APos,*AbscSt1,*AbscSt2,*AideSt,
      *ValSt,*XEd,*YEd,*FoncSelL,*CursorRB,*PointRB;
  GtkWidget *PanoramaB,*LimCurvesB,*FamilyB,*LevelB,*CrossB,*InflexB,*SaveB,*LoadB,*SaveImagePPMB,*SaveImageXPMB,*MergeB;
  GtkWidget *TraceCB,*RedrawB,*ZoomB,*AxesB,*CrbDelB,*FoncDelB;
  void AxesDialog();void ZoomDialog();

  //Zoom dialog
  void SetupZoomDial();
  GtkWidget *ZoomDial;
  GtkWidget *xlcEd,*ylcEd,*xechEd,*yechEd,*WAspEd,*xyEd;
  GtkWidget *xyWRB,*xWRB,*yWRB,*ZoomDialogOKB,*ZoomDialogCancelB;
  void ZoomDialogOK();void ZoomDialogCancel();

  //Axes dialog
  void SetupAxesDial();
  GtkWidget*AxesDial;
  GtkWidget *xgradEd,*ygradEd,*xaxeEd,*yaxeEd,*AxesDialogOKB,*AxesDialogCancelB,*AxesColorB,*WColorB;
  void AxesDialogOK();void AxesDialogCancel();
  GtkWidget *AxesColorSelDial,*WColorSelDial;
  void AxesColorSelDialog();
  void AxesColorSelDialogOK();
  void AxesColorSelDialogCancel();
  GdkColor AxesColor_temp;
  void WColorSelDialog();
  void WColorSelDialogOK();
  void WColorSelDialogCancel();
  GdkColor WColor_temp;

  //Options dialog
  void SetupOptDial();
  void OptDialog();
  void OptDialogOK();
  void OptDialogCancel();
  GtkWidget*OptDial;
  GtkWidget *ContRB,*ArrRB,*TestPtICB,*TestPtsCB;
  GtkWidget *OptDialogOKB,*OptDialogCancelB;
};

//char Analyse(TFonction*,double,double,
//	double,double,double&,double&);

inline double Fenetre::xlog(long int x){return((x-xpc)/xr*xech+xlc);}
inline double Fenetre::ylog(long int y){return((ypc-y)/yr*yech+ylc);}
inline long int Fenetre::xphys(double x){return((long int)((double)((x-xlc)*xr/xech)+xpc));}
inline long int Fenetre::yphys(double y){return((long int)(-(double)((y-ylc)*yr/yech)+ypc));}
